"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

/**
 * Schedule 类
 *
 * @author: sunkeysun
 */
class Schedule {
  constructor() {
    (0, _defineProperty2.default)(this, "_crontabs", []);
    (0, _defineProperty2.default)(this, "_command", '');
    (0, _defineProperty2.default)(this, "_options", {});
  }

  get crontabs() {
    return this._crontabs;
  }

  _addCrontab(expression) {
    const crontab = {
      expression,
      command: this._command,
      options: this._options
    };

    this._crontabs.push(crontab);
  }

  command(command, options = {}) {
    this._command = command;
    this._options = options;
    return this;
  }

  cron(expression) {
    this._addCrontab(expression);
  }

  everyMinute() {
    this._addCrontab('* * * * *');
  }

  hourly() {
    this._addCrontab('0 */1 * * *');
  }

  daily() {
    this._addCrontab('0 0 */1 * *');
  }

  monthly() {
    this._addCrontab('0 0 1 * *');
  }

  weekly() {
    this._addCrontab('0 0 * * 0');
  }

}

exports.default = Schedule;