"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = seqId;

var _uuid = require("uuid");

/**
 * seqId 中间件
 *
 * @author: sunkeysun
 */
async function seqId(ctx, next) {
  const requestConfig = app().config('app').request;
  const seqHeader = app().request.seqHeader;

  const seqId = ctx.request.headers[_.toLower(seqHeader)];

  if (requestConfig.seqId) {
    if (seqId) {
      process.context.set('seqId', seqId);
    } else {
      process.context.set('seqId', (0, _uuid.v4)());
    }
  }

  await next();
}