"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _Provider = _interopRequireDefault(require("../support/base/Provider"));

var _Router = _interopRequireDefault(require("./Router"));

/**
 * 路由服务提供者
 *
 * @author : sunkeysun
 */
class RoutingProvider extends _Provider.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "_router", new _Router.default());
  }

  register() {
    const routesPath = app().routesPath;

    const routeModule = require(routesPath).default;

    routeModule(this._router);

    const routes = this._router.routes();

    return routes;
  }

}

exports.default = RoutingProvider;