"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.config = config;
exports.normalizeMiddleware = normalizeMiddleware;

var _fs = _interopRequireDefault(require("fs"));

/**
 * 通用助手
 *
 * @author : sunkesyun
 */
function config(configName) {
  const configPath = `${app().configPath}/${configName}`;
  const env = app().env;
  const envConfigPath = `${app().configPath}/${env}/${configName}`;
  let configModule = null;

  if (_fs.default.existsSync(`${envConfigPath}.js`)) {
    configModule = require(envConfigPath);
  } else {
    configModule = require(configPath);
  }

  if (!_.isUndefined(configModule.default)) {
    configModule = configModule.default;
  }

  return configModule;
}

function normalizeMiddleware(middleware) {
  return async (ctx, next) => {
    const request = ctx.iRequest;
    const response = ctx.iResponse;
    await middleware(request, response, next);
  };
}