"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

require("./superGlobals");

var _RequestProvider = _interopRequireDefault(require("../request/RequestProvider"));

var _version = _interopRequireDefault(require("../version"));

/**
 * web 应用程序核心
 *
 * @author : sunkeysun
 */
global = typeof window !== undefined && window || void 0;

class Kernel extends _eventemitter.default {
  constructor({
    appConfig
  }) {
    super();
    (0, _defineProperty2.default)(this, "_request", null);
    (0, _defineProperty2.default)(this, "_logger", console);
    (0, _defineProperty2.default)(this, "_appConfig", {});
    (0, _defineProperty2.default)(this, "_events", {
      'request-error': Symbol('request-error')
    });
    (0, _defineProperty2.default)(this, "isBrowser", true);

    this._registerGlobal();

    this._appConfig = appConfig;
  }

  get version() {
    return `${_version.default.name}/${_version.default.version}`;
  }

  get request() {
    return this._request;
  }

  get logger() {
    return this._logger;
  }

  event(eventName) {
    if (!this._events[eventName]) {
      throw new Error(`event ${eventName} not supported, you can use app().events get event list`);
    }

    return this._events[eventName];
  }

  get events() {
    return _.keys(this._events);
  }

  _registerBaseProviders() {
    const requestConfig = _.get(this._appConfig, 'request', {});

    this._request = new _RequestProvider.default().register(requestConfig);
  }

  _registerGlobal() {
    _lodash.default.extend(global, {
      app: () => this
    });
  }

  run(render) {
    this._registerBaseProviders();

    render();
  }

}

exports.default = Kernel;